<%@include file="/shell/default.jspf"%>

<%@page import="com.sas.fsd.shared.util.StringUtil"%>
<%@page import="com.sas.solutions.casemgmt.i18n.AppProperties"%>
<%@page import="com.sas.solutions.casemgmt.util.UserDisplayUtil"%>
<%@page import="com.sas.solutions.casemgmt.web.entity.AttachmentActionModel"%>
<%@page import="com.sas.solutions.casemgmt.web.form.AttachmentForm" %>
<%@page import="com.sas.solutions.cpb.util.DateUtil"%>
<%@page import="com.sas.svcs.attachments.client.Attachment"%>

<%@ taglib prefix="sas" uri="http://www.sas.com/taglib/sas" %>

<%@include file="/ext/cpbcore/messages/ShowMessages.jsp" %>

<%
AttachmentActionModel model = AttachmentActionModel.getFromRequest(request);
AttachmentForm af = model.getForm();
long entityKey = Long.parseLong(af.getKey());
long entityTypeID = Long.parseLong(af.getObjType());
request.setAttribute("editable", new Boolean(model.isEditable()));
request.setAttribute("addable", new Boolean(model.isAddable()));
%>

<script type="text/javascript">
   var pageDirty = false;
   require(
      ['dojo/ready', 'dojo/_base/declare', 'dojo/parser', 'dojo/_base/array', 'dijit/TitlePane', 'dgrid/Grid', 
       'dgrid/extensions/ColumnResizer', 'dgrid/extensions/ColumnHider', 
       'dijit/form/Textarea', 'dojox/form/Uploader', 'dojox/form/uploader/FileList', 'dijit/form/Button', 
       'messages/Messages', 'dojo/store/Memory', 'dojo/dom-construct', 'dojo/dom-style', 'cpb'], 
      function(ready, declare, parser, array, TitlePane, Grid, ColumnResizer, ColumnHider, Textarea, 
            Uploader, FileList, Button, Messages, MemoryStore, domConstruct, domStyle, cpb)
      {

         updateFileList = function(uploader)
         {
            var fileListContainer = dojo.byId('fileList_container');
            var cb = {
              html: '',
              callback: function(item)
              {
                 this.html = item.name + "<br/>";
                 pageDirty = true;
              }    
            };
            array.forEach(uploader.getFileList(), cb.callback, cb);
            fileListContainer.innerHTML = cb.html;
            dijit.byId('uploadButton').set('disabled', false);
         };
         
         getMemoryStore = function(jsonData)
         {
            cpb.consoleLog("jsonData == " + jsonData);
            var store = new MemoryStore({ data: jsonData });
            return store;
         };
         
         getColumns = function(showFirst)
         {
            var columns = [];
            if (showFirst)
            {
               columns.push({ 
                  label: ' ', field: 'actionMenuColumn', unhidable: true, sortable: false, resizable: false,
                  renderCell: function(rowData, data, node, options) {
                     require(["dojo/dom-class"], function(domClass) {
                        if (!rowData.isEditable) 
                        { 
                           node.innerHTML = ' '; 
                           return; 
                        }
                        var url = "javascript:Attachment.deleteAttachment('" + rowData.id + "')";
                        var a = domConstruct.create('a', { href: '#' }, node);
                        a.addEventListener('click', function(e) {
                           e.stopPropagation(); e.preventDefault();
                           Attachment.deleteAttachment(rowData.id);
                        });
                        domConstruct.create("div", { className: 'sasDeleteIcon' }, a);
                     });
                  }
               });
            }
            columns.push({ 
               label: '<%=AppProperties.getProperty("field.attachment.attachment_name.header.txt", true)%>', 
               field: 'col2', unhidable: true, resizable: false, 
               renderCell: function(rowData, data, node, options) {
                  var url = "Attachments.do?command=download&key=" + rowData.id;
                  var a = document.createElement('a');
                  a.setAttribute('href', url);
                  a.setAttribute('target', '_blank');
                  a.appendChild(document.createTextNode(data));
                  node.appendChild(a);
               }
            });
            columns.push({ 
               label: '<%=AppProperties.getProperty("field.attachment.description.header.txt", true)%>',
               field: 'col3', unhidable: true
            });
            columns.push({ 
               label: '<%=AppProperties.getProperty("field.file.create_user_id.header.txt", true)%>',
               field: 'col4', unhidable: true
            });
            columns.push({ 
               label: '<%=AppProperties.getProperty("field.file.create_dttm.header.txt", true)%>',
               field: 'col5', unhidable: true
            });
            
            return columns;
         };
         
         getArrayData = function(showFirst)
         {
            var data = [];
            
            var linkColumn;
            var url = "Attachments.do?command=download&key=";
         <% for (Attachment a : model.getAllAttachments(entityKey, entityTypeID)) { %>
            
            data.push({
               isEditable: showFirst,
               id: '<%=a.getId()%>',
               col1: '<%=a.getId()%>',
               col2: '<%=StringUtil.escapeJSForHTML(a.getName())%>',
               col3: '<%=StringUtil.escapeJSForHTML(a.getDescription())%>',
               col4: '<%=UserDisplayUtil.getUserDisplayName(a.getCreator())%>',
               col5: '<%=DateUtil.formatPreferredDateTime(a.getCreatedOn(), request.getLocale())%>'
            });
         <% } %>
            return data;
         };
         
         ready(function() {
            var columns = getColumns(<%=model.isEditable() && model.isDeletable()%>);
            var json = eval("<%=StringUtil.escapeJSForHTML(model.getAllAttachmentsAsJSON(entityKey, entityTypeID))%>");
            var arrayData = getArrayData(<%=model.isEditable() && model.isDeletable()%>);
            var grid = new (declare([Grid, ColumnResizer, ColumnHider]))({
               id: 'attachmentGrid',
               columns: columns,
               noDataMessage: '<%=AppProperties.getProperty("table.default.no.rows.message.txt", true)%>',
               loadingMessage: '<%=AppProperties.getProperty("table.default.loading.message.txt", true)%>'
            }, 'attachmentGridDiv');
            grid.renderArray(arrayData);
         });
      }
   );
</script>

<div data-dojo-type='dijit/layout/BorderContainer' data-dojo-props="gutters: false, style: 'width: 100%; height: 100%'">

   <div data-dojo-type='dijit/layout/ContentPane' data-dojo-props='region: "center"'>
      <html:form method="post" action="/Attachments.do" enctype="multipart/form-data">
         <div id="mainContent">
            <html:hidden property="key" />
            <html:hidden property="objType" />
            <input type="hidden" id="attachmentID" name="attachmentID" />
            <input type="hidden" id="command" name="command" value="save" />
      
            <c:if test="${addable}">
               <div id="add_expand_collapse_div" data-dojo-type="dijit/TitlePane" 
                     data-dojo-props="closable: 'true', open: 'true', title: '<%=AppProperties.getProperty("section.attachments.add.header.txt", true) %>'">
                  <table width="98%" align="center">
                     <tr>
                        <td>
                           <label><%=AppProperties.getProperty("field.attachment.file.label.txt")%></label>
                        </td>
                        <td id="fileList_container"></td>
                     </tr>
                     <tr>
                        <td width="100px">
                           <label for="description"><%=AppProperties.getProperty("field.attachment.description.label.txt")%></label>
                        </td>
                        <td></td>
                     </tr>
                     <tr>
                        <td colspan="2">
                           <textarea id="description" name="description" data-dojo-type="dijit/form/Textarea" 
                                 style="width:98%;" rows="5" 
                                 onkeyup="App.limitText(this, ${maxDescriptionSize});" 
                                 onchange="pageDirty = true;"></textarea>
                        </td>
                     </tr>
                  </table>
                  <input name="file" data-dojo-type="dojox/form/Uploader" multiple="false" 
                              label="<%=AppProperties.getProperty("button.attachments.upload.txt")%>" 
                              onchange="updateFileList(this)" /> <%--If you define the type="file" then it will create an offscreen version causing problems uploading --%>
                  <button id="uploadButton" data-dojo-type="dijit/form/Button" disabled="true" 
                     onClick="Upload.upload('AttachmentForm', this, 'attachmentSpinner')"><%=AppProperties.getActionLabel("attachment.commit")%></button>
                  <div id='attachmentSpinner' style='display: none'></div>
               </div>
            </c:if>
            <div id="list_expand_collapse_div" data-dojo-type="dijit/TitlePane"  
                  data-dojo-props="closable: 'true', open: 'true', title: '<%= AppProperties.getProperty("section.attachments.list.header.txt", true) %>'">
               <%-- model.writeAttachmentTable(entityKey, entityTypeID, pageContext); --%>
               <div id="attachmentGridDiv"></div>
            </div>
      	</div>
      </html:form>
   </div>
   <div data-dojo-type='dijit/layout/ContentPane' data-dojo-props='region: "bottom", style: "top: 0px; width: 100%"' class="dijitDialogPaneActionBar">
      <button data-dojo-type="dijit/form/Button" onClick="Attachment.close(pageDirty)"><%=AppProperties.getActionLabel("close")%></button>
   </div>
</div>